<!-- goods 商品管理 -->
<template>
  <div>

    <div class=" mb10">
      <zw-row>
        <zw-row class="mr20">
          <span>标题：</span>
          <el-input clearable class="w200 " v-model="search_data.search" placeholder="搜索"></el-input>
        </zw-row>
        <zw-row class="mr20">
          <span>是否推荐：</span>
          <zw-select class="w120" placeholder="全部" v-model="search_data.is_recommend" :List="locBaseData.is" />
        </zw-row>
        <zw-row class="mr20">
          <span>店铺分类：</span>
          <zw-select class="w120" placeholder="全部" v-model="search_data.filter_creator_by" :List="locBaseData.filterGoodsByCreator" />
        </zw-row>
<!-- 
        <zw-row class="mr20">
          <span>是否新品：</span>
          <zw-select class="w120" placeholder="全部" v-model="search_data.is_new" :List="locBaseData.is" />
        </zw-row> -->

        <zw-row class="mr20">
          <span>上架状态：</span>
          <zw-select class="w120" placeholder="全部" v-model="search_data.on_sale" :List="locBaseData.on_sale" />
        </zw-row>

        <!-- <zw-row class="mr20">
          <span>是否包邮：</span>
          <zw-select class="w120" placeholder="全部" v-model="search_data.ship_free" :List="locBaseData.is" />
        </zw-row> -->

         <zw-row class="mr20">
          <span>分类：</span>
          <goodss-class-select v-model="search_data.cid" />
        </zw-row>
      </zw-row>

      <zw-row class="mt10">
        

       

      </zw-row>

      <div class="mt10">
        <el-button size="small" icon="el-icon-search" @click.native="m_search" type="primary">搜索</el-button>
        <el-button size="small" icon="el-icon-plus" @click="m_add" type="success">添加</el-button>
        <el-button size="small" icon="el-icon-delete" @click.native="m_del" type="danger">批量删除</el-button>
         <el-button v-if="userInfo.group_id != 2" size="small" @click.native="goodsFetchShow=true" type="primary">产品抓取</el-button>
      </div>

    </div>

    <el-table ref="m_table" size="mini" border :max-height="tableHeight" v-loading="m_tableLoading" @selection-change="m_handleSelectionChange" @current-change="m_handleCurrentChange" :stripe="true" tooltip-effect="dark" :highlight-current-row="true" :data="m_list">
      <el-table-column type="selection" align="center" width="55"></el-table-column>
      <el-table-column prop="" show-overflow-tooltip align="center" label="图片" width="100">
        <template slot-scope="scope">
          <img class="ad_img" v-if="scope.row.images[0]" :src="scope.row.images[0]" alt>
        </template>
      </el-table-column>
      <el-table-column prop="title" show-overflow-tooltip align="center" label="标题"> </el-table-column>
      <el-table-column prop="seller_name" show-overflow-tooltip align="center" label="Seller Name"> </el-table-column>
      <el-table-column prop="title" show-overflow-tooltip align="center" label="状态">
        <template slot-scope="scope">
          <el-button class="m_edit" @click="handelStatus(scope.row,'is_recommend')" :loading="scope.row.is_recommend_loading"  size="small" type="text"><span :class="scope.row.is_recommend | textBtnClass">推荐</span></el-button>
          <!-- <el-button class="m_edit" @click="handelStatus(scope.row,'ship_free')" :loading="scope.row.ship_free_loading"  size="small" type="text"><span :class="scope.row.ship_free  | textBtnClass">包邮</span></el-button> -->
           <!-- <el-button class="m_edit" @click="handelStatus(scope.row,'ship_free')" :loading="scope.row.is_commission"  size="small" type="text"><span :class="scope.row.is_commission | textBtnClass">分销 </span></el-button> -->
            <el-button class="m_edit" @click="handelStatus(scope.row,'is_hot')" :loading="scope.row.is_hot_loading"  size="small" type="text"><span :class="scope.row.is_hot | textBtnClass">爆款 </span></el-button>
          <!-- <el-button class="spanr" @click="handelStatus(scope.row,'is_new')"  :loading="scope.row.is_new_loading" size="small" type="text"><span :class="scope.row.is_new | textBtnClass">新品</span></el-button> -->
          <el-button class="spanr" @click="handelStatus(scope.row,'on_sale')" :loading="scope.row.on_sale_loading"  size="small" type="text"><span :class="scope.row.on_sale | textBtnClass">{{scope.row.on_sale | getLocBaseData('on_sale')}}</span></el-button>
        </template>

      </el-table-column>

      <el-table-column label="操作" width="200" align="center">
        <template slot-scope="scope">
          <el-button class="m_edit" size="small" @click.native='copy(scope.row)' type="text"><span class="m_blue">复制链接</span></el-button>
          <el-button class="m_edit" size="small" @click.native='m_edit(scope.row)' type="text"><span class="m_blue">编辑</span></el-button>
          <el-button class="spanr" size="small" @click.native='m_oneDel(scope.row)' type="text"><span class="m_red">删除</span></el-button>

        </template>
      </el-table-column>

    </el-table>

    <goodsFetch v-if="goodsFetchShow" v-model="goodsFetchShow"  @save-after="afterSave"  />

    <addFormDialog  :id="e_id" v-if="m_show" v-model="m_show" @handelSubmit="afterSave" />

    <Paging class="mt20 mb30" :pageIndex="m_page.page" :pageSize="m_page.limit" :pageTotal="m_page.total" @changeSize="m_changesize" @changeIndex="m_changeindex"></Paging>

  </div>
</template>

<script>
import addFormDialog from './components/addFormDialog.vue'
import goodssClassSelect from './components/goodssClassSelect'
import goodsFetch from "./components/goodsFetch"
export default {
  name: 'goods',
  components: { goodssClassSelect ,addFormDialog , goodsFetch },
  data() {
    return {
      e_id: '',
      search_data: {
        search: '', //上架状态 0: 下架  1:上架
        is_recommend: '',// 是否推荐
        is_new: '',// 是否新品
        ship_free: '',// 是否包邮
        cid: '',// cid
        on_sale: '',// 上架状态 0: 下架  1:上架
        filter_creator_by: '', // Filter creator 0: admin, 1: seller
      },
      m_show:false,
      goodsFetchShow:false,
      userInfo: []
      
    };
  },
  mounted() {
  },

  activated() {
    if (this.$route.query.keep != 1) {
      this.m_resetData()
      this.init()
    } else {

    }
  },
  methods: {

    init() {
      this.getDatalist()
      this.userInfo = JSON.parse(sessionStorage.userInfo);
      console.log(this.userInfo);
    },

    getDatalist() {
      let data = { ...this.search_data, ...this.m_page }
      this.m_api.goods(data).then(res => {
        console.log(res)
        res.data.data = res.data.data.map(i => {
          i.is_recommend_loading = false
          i.is_new_loading = false
          i.ship_free_loading = false
          i.on_sale_loading = false
           i.is_hot_loading = false
          return i
        })
        this.m_list = res.data.data
        this.m_page.total = res.data.total
      })
    },


    delData(id) {
      let m_delId = id ? [id] : this.m_delId
      this.m_loading = true
      this.m_api.goods_delete(m_delId).then(res => {
        this.m_loading = false
        // 删除成功
        this.m_success('删除成功')
        this.getDatalist()
      }).catch(res => {
        this.m_loading = false
      })
    },


    m_add() {
      this.m_isadd = true
      this.e_id = ''
      this.$nextTick(() => {
        this.m_show = true
        console.log(this.m_show)
      })

    },

    //编辑
    m_edit(row) {
      this.m_isadd = false
      this.e_id = row.id
      this.$nextTick(() => {
        this.m_show = true
      })

    },

    copy(row) {
      let url = `/goodsDetail?id=${row.id}`
      this.m_copy( url, () => {
        this.m_success('复制成功')
      })

    },


    submit() {
      if (this.m_isadd) {
        this.m_success('添加成功')
        this.getDatalist()

      } else {
        this.m_success('修改成功')
        this.getDatalist()
      }
      this.m_show = false
    },

    handelStatus(row, type) {
      let value = row[type] == 1 ? '0' : '1'
      let data = {
        id: [row.id],
        value,
        type
      }
      row[type+'_loading'] = true
      this.m_api.goods_set_status(data).then(res => {
        row[type] = value
         row[type+'_loading'] = false
      }).catch(err=>{
          row[type+'_loading'] = false
      })
    },

    afterSave(){
      this.getDatalist()
    }


  },


}
</script>
<style lang='scss' scoped>
.ad_img {
  width: 70px;
  height: 70px;
}
.tip {
  font-size: 19px;
  margin-bottom: 30px;
}
</style>